-- Sounds
freeslot("sfx_dogtoy", "sfx_metalp", "sfx_dogt2", "sfx_fparry", "sfx_fparr2")
sfxinfo[sfx_dogtoy].caption = "Squeak"
sfxinfo[sfx_dogt2].caption = "Ssquueeaak"
sfxinfo[sfx_fparry].caption = "Parry"
sfxinfo[sfx_fparr2].caption = "Parried!"

-- Objects
freeslot("MT_DUMMYOBJ", "S_DUMMYSTATE", "SPR_BLBS", "SPR_FLIM", "SPR_SUPF")

mobjinfo[MT_DUMMYOBJ] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_DUMMYSTATE,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY
}
states[S_DUMMYSTATE] = {SPR_NULL, A, -1, nil, 0, 0, S_DUMMYSTATE}

-- States
freeslot("SPR2_DUCK", "S_PLAY_BLOSSOM_DUCKDANCE")
states[S_PLAY_BLOSSOM_DUCKDANCE] = {SPR_PLAY, SPR2_DUCK, 4, nil, 0, 0, S_PLAY_BLOSSOM_DUCKDANCE}

-- That's crazy
if not P_MoveOrigin then rawset(_G, "P_MoveOrigin", P_TeleportMove) end
if not P_SetOrigin then rawset(_G, "P_SetOrigin", P_TeleportMove) end

-- ok
rawset(_G, "hasShield", function(p, shield)
	if p.powers[pw_super] then return false end
	return (p.powers[pw_shield] & SH_NOSTACK) == shield
end)